define([
    "../../widgets/ListWidget",
    "./QuestionEditorPreviewItem",
    "dijit/registry",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct"
], function(ListWidget, QuestionEditorPreviewItem, registry, array, declare, lang, domConstruct) {
    return declare([ListWidget], {
        baseClass: 'surveyEditorPreview',
        type: 'questionContent',
        withHandles: true,

        createAvatar: function(id, item) {
            return domConstruct.create("div",{
                innerHTML: item.type || "(unkown)"
            });
        },
        createListElement: function(id, item) {
            var previewItem = new QuestionEditorPreviewItem({
                id: id,
                value: item
            });
            previewItem.showEdit();
            this.own(previewItem.on('destroy',
                                    lang.hitch(this,'removeItem',id,true)));
            previewItem.startup();
            return previewItem;
        }
    });
});
