define([
    "../../../lib/object",
    "./HeaderConfigWidget",
    "./HeaderWidget",
    "./MultipleChoiceInputConfigWidget",
    "./MultipleChoiceInputWidget",
    "./NumberInputConfigWidget",
    "./NumberInputWidget",
    "./ScaleInputConfigWidget",
    "./ScaleInputWidget",
    "./SingleChoiceInputConfigWidget",
    "./SingleChoiceInputWidget",
    "./StringInputConfigWidget",
    "./StringInputWidget",
    "./TextConfigWidget",
    "./TextInputConfigWidget",
    "./TextInputWidget",
    "./TextWidget",
    "dijit/_WidgetBase",
    "dojo/_base/declare"
], function(objectFuns, HeaderConfigWidget, HeaderWidget, MultipleChoiceInputConfigWidget, MultipleChoiceInputWidget, NumberInputConfigWidget, NumberInputWidget, ScaleInputConfigWidget, ScaleInputWidget, SingleChoiceInputConfigWidget, SingleChoiceInputWidget, StringInputConfigWidget, StringInputWidget, TextConfigWidget, TextInputConfigWidget, TextInputWidget, TextWidget, _WidgetBase, declare) {
    
    var DividerWidget = declare([_WidgetBase], {
        postCreate: function() {
            this.domNode.innerHTML = "<hr>";
        }
    });

    var viewMap = {
        Header: HeaderWidget,
        Text: TextWidget,
        Divider: DividerWidget,
        StringInput: StringInputWidget,
        TextInput: TextInputWidget,
        NumberInput: NumberInputWidget,
        MultipleChoiceInput: MultipleChoiceInputWidget,
        SingleChoiceInput: SingleChoiceInputWidget,
        ScaleInput: ScaleInputWidget
    };
    var editMap = {
        Header: HeaderConfigWidget,
        Text: TextConfigWidget,
        StringInput: StringInputConfigWidget,
        TextInput: TextInputConfigWidget,
        NumberInput: NumberInputConfigWidget,
        MultipleChoiceInput: MultipleChoiceInputConfigWidget,
        SingleChoiceInput: SingleChoiceInputConfigWidget,
        ScaleInput: ScaleInputConfigWidget
    };

    editMap = objectFuns.map(editMap,function(Ctor,type){
        return declare([Ctor],{
            _getValueAttr: function() {
                var value = this.inherited(arguments);
                value.type = type;
                return value;
            }
        });
    });

    var factory = declare(null, {
        createViewWidget: function(/*Object*/options) {
            // options: Object
            //            type: "Header", "Text", "TextInput", etc.
            //            other type specific fields
            var Ctor = viewMap[options.type];
            var view = Ctor && new Ctor(options) || null;
            return view;
        },
        createEditWidget: function(/*Object*/options) {
            var Ctor = editMap[options.type];
            var edit = Ctor && new Ctor({
                value: options
            });
            return edit || null;
        }
    });

    return factory;
});
