define([
    "../../../widgets/ListWidget",
    "../../../widgets/_ComplexValueWidget",
    "dijit/form/Button",
    "dijit/form/RadioButton",
    "dijit/form/TextBox",
    "dijit/form/ValidationTextBox",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/event",
    "dojo/_base/lang",
    "dojo/dom-attr",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/text!./templates/ScaleInputConfigRowWidget.html",
    "dojo/text!./templates/ScaleInputConfigWidget.html",
    "dijit/form/NumberTextBox",
    "dijit/form/TextBox"
], function(ListWidget, _ComplexValueWidget, Button, RadioButton, TextBox, ValidationTextBox, array, declare, event, lang, domAttr, domConstruct, domStyle, rowTemplate, template) {

    var Row = declare([_ComplexValueWidget],{
        templateString: rowTemplate,
        hasNA: true,
        startup: function() {
            if ( this._started ) { return; }
            this.inherited(arguments);
        },
        onDestroy: function(evt) {},
        _setHasNAAttr: function(value) {
            if ( value === true ) {
                domStyle.set(this.naRadioButton.domNode, "display", "");
            } else {
                domStyle.set(this.naRadioButton.domNode, "display", "none");
            }
        }
    });
    
    return declare([_ComplexValueWidget],{
        templateString: template,
        baseClass: "qedScaleWidget",
        _hasNA: false,
        constuctor: function() {
            this.inherited(arguments);
            this.value = {};
        },
        buildRendering: function() {
            this.inherited(arguments);
            this.itemsWidget = new ListWidget({
                name: "items",
                type: "ScaleItem",
                delay: 5,
                skipForm: true,
                createListElement: lang.hitch(this, "_createRowWidget"),
                createAvatar: lang.hitch(this, "_createAvatar")
            }, this.itemsNode);
        },
        _createRowWidget: function(id, item) {
            var widget = new Row({
                value: item,
                hasNA: this._hasNA,
                id: id,
                onDestroy: lang.hitch(this,function(evt){
                    this.itemsWidget.removeItem(id,true);
                    if ( evt ) { event.stop(evt); }
                    return false;
                })
            });
            widget.startup();
            return widget;
        },
        _createAvatar: function(id, item) {
            return domConstruct.create("div", {
                innerHTML: item.text || "(empty item)"
            });
        },
        onAddNewItem: function(e) {
            this.itemsWidget.appendItem({},true);
            if ( e ) { event.stop(e); }
            return false;
        },
        onNAChange: function(value) {
            this._hasNA = value !== null && value !== "";
            this._updateNA();
        },
        _updateNA: function(value) {
            array.forEach(this.itemsWidget.getChildren(), function(child) {
                child.set('hasNA', this._hasNA);
            }, this);
        }
    });
});
