define([
    "dijit/_Container",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetBase",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/RadioButton",
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/dom-construct",
    "dojo/text!./templates/SingleChoiceInputWidget.html"
], function(_Container, _TemplatedMixin, _WidgetBase, _WidgetsInTemplateMixin, RadioButton, array, declare, domConstruct, template) {
    return declare([_WidgetBase,_TemplatedMixin,_WidgetsInTemplateMixin,_Container],{
        templateString: template,
        startup: function() {
            if ( this._started ) { return; }
            this.inherited(arguments);

            domConstruct.empty(this.domNode);
            array.forEach(this.items, function(item){
                var div = domConstruct.create("div", {
                }, this.domNode, "last");
                var input = new RadioButton({
                    name: this.code + this.subcode,
                    value: item.value
                }).placeAt(div);
                var label = domConstruct.create("label",{
                    'for': input.id,
                    innerHTML: item.text
                }, div);
            }, this);
        }
    });
});
